'use strict';

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.withMutations = exports.updateIn = exports.deleteIn = exports.setIn = exports.getIn = exports.get = exports.getUIState = void 0;

var _getIterator2 = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/get-iterator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _invariant = _interopRequireDefault(require("invariant"));

var DONE_STEP = {
  done: true
};

var ForcedIterator =
/*#__PURE__*/
function () {
  function ForcedIterator(value) {
    (0, _classCallCheck2["default"])(this, ForcedIterator);
    (0, _assign["default"])(this, {
      __source: value,
      currentPosition: -1
    });
  }

  (0, _createClass2["default"])(ForcedIterator, [{
    key: "next",
    value: function next() {
      var done = this.currentPosition === this.__source.length - 1;
      if (done) return DONE_STEP;
      this.currentPosition++;
      var value = done ? undefined : this.__source[this.currentPosition];
      return (0, _assign["default"])({}, {
        done: done,
        value: value
      });
    }
  }]);
  return ForcedIterator;
}(); // TODO: Make this truly Mutable


var Mutable =
/*#__PURE__*/
function () {
  function Mutable(state) {
    (0, _classCallCheck2["default"])(this, Mutable);
    (0, _assign["default"])(this, {
      state: state
    });
  }

  (0, _createClass2["default"])(Mutable, [{
    key: "get",
    value: function get(key) {
      return __get(this.state, key);
    }
  }, {
    key: "getIn",
    value: function getIn(searchKeyPath, notSetValue) {
      return __getIn(this.state, searchKeyPath, notSetValue);
    }
  }, {
    key: "updateIn",
    value: function updateIn(keyPath, notSetValue, updater) {
      this.state = __updateIn(this.state, keyPath, notSetValue, updater);
    }
  }, {
    key: "setIn",
    value: function setIn(keyPath, v) {
      this.state = __setIn(this.state, keyPath, v);
    }
  }, {
    key: "deleteIn",
    value: function deleteIn(keyPath) {
      this.state = __deleteIn(this.state, keyPath);
    }
  }, {
    key: "withMutations",
    value: function withMutations(fn) {
      this.state = __withMutations(this.state, fn);
    }
  }]);
  return Mutable;
}();

var isArrayLike = function isArrayLike(value) {
  return value && typeof value.length === 'number';
};

var forceIterator = function forceIterator(keyPath) {
  if (!isArrayLike(keyPath)) {
    throw new TypeError('Expected iterable or array-like: ' + keyPath);
  }

  return new ForcedIterator(keyPath);
};

var updateInDeepMap = function updateInDeepMap(existing, keyPathIter, notSetValue, updater) {
  var isNotSet = typeof existing === 'undefined';
  var step = keyPathIter.next();

  if (step.done) {
    var existingValue = isNotSet ? notSetValue : existing;
    var newValue = updater(existingValue);
    return newValue === existingValue ? existing : newValue;
  }

  (0, _invariant["default"])(isNotSet || existing && Object(existing) === existing, 'invalid keyPath');
  var key = step.value;
  var nextExisting = isNotSet ? undefined : existing[key];
  var nextUpdated = updateInDeepMap(nextExisting, keyPathIter, notSetValue, updater);

  if (nextUpdated === nextExisting) {
    return existing;
  } else if (typeof nextUpdated === 'undefined') {
    var result = (0, _objectSpread3["default"])({}, existing);
    delete result[key];
    return result;
  } else {
    return isNotSet ? (0, _defineProperty2["default"])({}, key, nextUpdated) : (0, _objectSpread3["default"])({}, existing, (0, _defineProperty2["default"])({}, key, nextUpdated));
  }
};

var __get = function __get(state, key) {
  return state[key];
};

var __getIn = function __getIn(state, searchKeyPath, notSetValue) {
  var nested = state;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator2["default"])(searchKeyPath), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;
      nested = nested ? nested[key] : undefined;

      if (typeof nested === 'undefined') {
        return notSetValue;
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return nested;
};

var __updateIn = function __updateIn(state, keyPath, notSetValue, updater) {
  if (!updater) {
    updater = notSetValue;
    notSetValue = undefined;
  }

  var updatedValue = updateInDeepMap(state, forceIterator(keyPath), notSetValue, updater);
  return updatedValue;
};

var __setIn = function __setIn(state, keyPath, v) {
  return __updateIn(state, keyPath, undefined, function () {
    return v;
  });
};

var __deleteIn = function __deleteIn(state, keyPath) {
  return __updateIn(state, keyPath, function () {
    return undefined;
  });
};

var __withMutations = function __withMutations(state, fn) {
  var mutable = new Mutable(state);
  fn(mutable);
  return mutable.state;
};
/**
 * getUIState inspects redux' global state store and returns the UI state node.
 *
 * This checks to see whether state is an immutable map or a POJO.
 */


var getUIState = function getUIState(state) {
  if (typeof state.get === 'function') {
    return state.get('ui');
  }

  return state.ui;
};
/**
 * get behaves similarly to Immutable.JS' Map's get function.
 *
 * This checks to see whether state is an immutable map or a POJO.
 */


exports.getUIState = getUIState;

var get = function get(state, key) {
  if (typeof state.get === 'function') {
    return state.get(key);
  }

  return __get(state, key);
};
/**
 * getIn behaves similarly to Immutable.JS' Map's getIn function.
 *
 * This checks to see whether state is an immutable map or a POJO.
 */


exports.get = get;

var getIn = function getIn(state, searchKeyPath, notSetValue) {
  if (typeof state.getIn === 'function') {
    return state.getIn(searchKeyPath, notSetValue);
  }

  return __getIn(state, searchKeyPath, notSetValue);
};
/**
 * setIn behaves similarly to Immutable.JS' Map's setIn function.
 *
 * This checks to see whether state is an immutable map or a POJO.
 */


exports.getIn = getIn;

var setIn = function setIn(state, keyPath, v) {
  if (typeof state.setIn === 'function') {
    return state.setIn(keyPath, v);
  }

  return __setIn(state, keyPath, v);
};
/**
 * deleteIn behaves similarly to Immutable.JS' Map's deleteIn function.
 *
 * This checks to see whether state is an immutable map or a POJO.
 */


exports.setIn = setIn;

var deleteIn = function deleteIn(state, keyPath) {
  if (typeof state.deleteIn === 'function') {
    return state.deleteIn(keyPath);
  }

  return __deleteIn(state, keyPath);
};
/**
 * updateIn behaves similarly to Immutable.JS' Map's updateIn function.
 *
 * This checks to see whether state is an immutable map or a POJO.
 */


exports.deleteIn = deleteIn;

var updateIn = function updateIn(state, keyPath, notSetValue, updater) {
  if (typeof state.updateIn === 'function') {
    return state.updateIn(keyPath, notSetValue, updater);
  }

  return __updateIn(state, keyPath, notSetValue, updater);
};
/**
 * withMutations behaves similarly to Immutable.JS' Map's withMutations function.
 *
 * This checks to see whether state is an immutable map or a POJO.
 */


exports.updateIn = updateIn;

var withMutations = function withMutations(state, fn) {
  if (typeof state.withMutations === 'function') {
    return state.withMutations(fn);
  }

  return __withMutations(state, fn);
};

exports.withMutations = withMutations;